sg.modules.rings={}

sg.modules.rings.limit=128
sg.modules.rings.currentringid=1

sg.modules.rings.base=initArray2(sg.modules.rings.limit,0)
sg.modules.rings.ring=initArray2(sg.modules.rings.limit,0)
sg.modules.rings.pos=initArray3(sg.modules.rings.limit,{0,0})
sg.modules.rings.owner=initArray2(sg.modules.rings.limit,0)
sg.modules.rings.address=initArray2(sg.modules.rings.limit,"")
sg.modules.rings.invisible=initArray2(sg.modules.rings.limit,false)

function sound3(snd,x,y,rx,ry)
	for id=1,32 do
		if (player(id,"exists") and player(id,"x")>=x-rx and player(id,"x")<=x+rx and player(id,"y")>=y-ry and player(id,"y")<=y+ry and snd~=nil) then
			parse("sv_sound2 "..id.." \""..snd.."\"")
		end
	end
end

function findByName(s)
	for rings=1,sg.modules.rings.currentringid-1 do
		if (s==sg.modules.rings.address[rings]) then
			return rings
		else
			return "none found"
		end
	end
end

----------------------------------
-- RINGS INITIALIZING FUNCTIONS --
----------------------------------

function sg.modules.rings.create(ply,x,y)
	if (sg.modules.rings.currentringid<=sg.modules.rings.limit) then
		if (sg.modules.debug) then
			print("115110255Stargate debug: player "..player(ply,"name").." with ID #"..ply.." has spawned ring base #"..sg.modules.rings.currentringid)
		end
		sg.modules.rings.base[sg.modules.rings.currentringid]=image("gfx/goauld_ringbase.png",x,y,0)
		sg.modules.rings.pos[sg.modules.rings.currentringid][1]=x
		sg.modules.rings.pos[sg.modules.rings.currentringid][2]=y
		sg.modules.rings.pos[sg.modules.rings.currentringid][3]=math.floor(x/32)
		sg.modules.rings.pos[sg.modules.rings.currentringid][4]=math.floor(y/32)
		sg.modules.rings.owner[sg.modules.rings.currentringid]=ply
		if (sg.modules.debug) then
			print("115110255Stargate debug: ring base #"..sg.modules.rings.currentringid.." installed successfully")
		end
		sg.modules.rings.currentringid=sg.modules.rings.currentringid+1
	end
end

function sg.modules.rings.remove(ring,x,y)
	if (sg.modules.debug) then
		print("115110255Stargate debug: removing ring base #"..ring)
	end
	freeimage(sg.modules.rings.base[ring])
	sg.modules.rings.base[ring]=0
	sg.modules.rings.pos[ring][1]=0
	sg.modules.rings.pos[ring][2]=0
	sg.modules.rings.owner[ring]=0
	if (sg.modules.debug) then
		print("115110255Stargate debug: ring base #"..ring.." removed successfully")
	end
end

function plyInRange(ply,x,y,rx,ry)
	if (player(ply,"exists") and player(ply,"x")<=x+rx and player(ply,"x")>=x-rx and player(ply,"y")<=y+ry and player(ply,"y")>=y-ry) then
		return true
	else
		return false
	end
end

-----------------------------
-- RINGS DIALING FUNCTIONS --
-----------------------------

sg.modules.rings.dialing=initArray2(sg.modules.rings.limit,false)
sg.modules.rings.dialedto=initArray2(sg.modules.rings.limit,0)
sg.modules.rings.glowimg=initArray2(sg.modules.rings.limit,0)

function sg.modules.rings.teleport(ply,ring)
	parse("setpos "..ply.." "..sg.modules.rings.pos[ring][1].." "..sg.modules.rings.pos[ring][2])
end

function sg.modules.rings.glow(ring)
	sg.modules.rings.glowimg[ring]=image("gfx/sprites/flare1.bmp",sg.modules.rings.pos[ring][1],sg.modules.rings.pos[ring][2],1)
	imageblend(sg.modules.rings.glowimg[ring],1)
	imagecolor(sg.modules.rings.glowimg[ring],255,235,0)
	timer(1000,"parse","lua freeimage(sg.modules.rings.glowimg["..ring.."])")
end

function sg.modules.rings.dial(ring1,ring2)
	if not (sg.modules.rings.dialing[ring1] and sg.modules.rings.dialing[ring2]) then
		if (ring1~=ring2) then
			if (sg.modules.debug) then
				print("115110255Stargate debug: ring platform #"..ring1.." is dialing ring platform #"..ring2)
			end
			sg.modules.rings.dialing[ring1]=true
			sg.modules.rings.dialing[ring2]=true
			sg.modules.rings.dialedto[ring1]=ring2
			sg.modules.rings.dialedto[ring2]=ring1
			sound3("stargate/rings1.ogg",sg.modules.rings.pos[ring1][1],sg.modules.rings.pos[ring1][2],128,128)
			sound3("stargate/rings1.ogg",sg.modules.rings.pos[ring2][1],sg.modules.rings.pos[ring2][2],128,128)
			if not (sg.modules.rings.invisible[ring1]) then
				freeimage(sg.modules.rings.base[ring1])
			end
			if not (sg.modules.rings.invisible[ring2]) then
				freeimage(sg.modules.rings.base[ring2])
			end
			timer(2000,"parse","lua sg.modules.rings.ring["..ring1.."]=image(\"gfx/goauld_ring.png\","..sg.modules.rings.pos[ring1][1]..","..sg.modules.rings.pos[ring1][2]..",3)")
			timer(2000,"parse","lua sg.modules.rings.ring["..ring2.."]=image(\"gfx/goauld_ring.png\","..sg.modules.rings.pos[ring2][1]..","..sg.modules.rings.pos[ring2][2]..",3)")
			timer(4000,"parse","lua sg.modules.rings.glow("..ring1..")")
			timer(4000,"parse","lua sg.modules.rings.glow("..ring2..")")
			for id=1,32 do
				if (plyInRange(id,sg.modules.rings.pos[ring1][1],sg.modules.rings.pos[ring1][2],64,64)) then
					timer(4000,"parse","lua sg.modules.rings.teleport("..id..","..ring2..")")
				end
			end
			for ply=1,32 do
				if (plyInRange(ply,sg.modules.rings.pos[ring2][1],sg.modules.rings.pos[ring2][2],64,64)) then
					timer(4000,"parse","lua sg.modules.rings.teleport("..ply..","..ring1..")")
				end
			end
			timer(4750,"parse","lua sound3(\"stargate/rings2.ogg\","..sg.modules.rings.pos[ring1][1]..","..sg.modules.rings.pos[ring1][2]..",128,128)")
			timer(4750,"parse","lua sound3(\"stargate/rings2.ogg\","..sg.modules.rings.pos[ring2][1]..","..sg.modules.rings.pos[ring2][2]..",128,128)")
			timer(6750,"parse","lua freeimage(sg.modules.rings.ring["..ring1.."])")
			timer(6750,"parse","lua freeimage(sg.modules.rings.ring["..ring2.."])")
			timer(6750,"parse","lua sg.modules.rings.ring["..ring1.."]=0")
			timer(6750,"parse","lua sg.modules.rings.ring["..ring2.."]=0")
			timer(6750,"parse","lua sg.modules.rings.dialing["..ring1.."]=false")
			timer(6750,"parse","lua sg.modules.rings.dialing["..ring2.."]=false")
			if not (sg.modules.rings.invisible[ring1]) then
				timer(7750,"parse","lua sg.modules.rings.base["..ring1.."]=image(\"gfx/goauld_ringbase.png\","..sg.modules.rings.pos[ring1][1]..","..sg.modules.rings.pos[ring1][2]..",0)")
			end
			if not (sg.modules.rings.invisible[ring2]) then
				timer(7750,"parse","lua sg.modules.rings.base["..ring2.."]=image(\"gfx/goauld_ringbase.png\","..sg.modules.rings.pos[ring2][1]..","..sg.modules.rings.pos[ring2][2]..",0)")
			end
		end
	end
end

------------------------------
-- USER INTERFACE FUNCTIONS --
------------------------------

sg.modules.rings.addressmode=initArray2(32,false)
sg.modules.rings.userinputting=initArray2(32,false)
sg.modules.rings.ringstack=initArray2(32,0)
sg.modules.rings.hud=initArray2(32,0)

addhook("menu","sg.modules.rings.menu")
function sg.modules.rings.menu(id,menu,sel)
	if (menu=="Stargate Extras") then
		if (sel==1) then
			sg.modules.rings.create(id,player(id,"x"),player(id,"y"))
		end
	end
	if (menu=="Goa'uld Ring Transporter") then
		if (sel==1) then
			sg.modules.rings.addressmode[id]=true
			msg2(id,"Please enter an address (10 characters only).")
		end
		if (sel==2) then
			sg.modules.rings.userinputting[id]=true
		end
		if (sel==3) then
			sg.modules.rings.remove(sg.modules.rings.ringstack[id])
			sg.modules.rings.ringstack[id]=0
		end
	end
end

function sg.modules.rings.ringmenu(id,ring)
	if (id==sg.modules.rings.owner[ring]) then
		sg.modules.rings.ringstack[id]=ring
		menu(id,"Goa'uld Ring Transporter,Set Address,Dial,Remove")
	else
		sg.modules.rings.ringstack[id]=ring
		menu(id,"Goa'uld Ring Transporter,,Dial")
	end
end

addhook("use","sg.modules.rings.settings")
function sg.modules.rings.settings(id)
	for rings=1,sg.modules.rings.currentringid-1 do
		if (player(id,"tilex")==sg.modules.rings.pos[rings][3] and player(id,"tiley")==sg.modules.rings.pos[rings][4]) then
			sg.modules.rings.ringmenu(id,rings)
		end
	end
end

-----------------------------------------
-- GATESPAWNER RING SPAWNING FUNCTIONS --
-----------------------------------------