print("-------------------------")
print("STARGATE MOD INITIALIZING")
print("-------------------------")

VERSION = 1.5

------------------------
-- TABLE INITIALIZING --
------------------------

if sg==nil then sg={} end

print("Base table initialized! Proceeding...")

---------------------------------
-- BASE FUNCTIONS INITIALIZING --
---------------------------------

sg.modules={}

function initArray2(f,v)
    local cmd = {}
    for c = 1, f do
    	cmd[c] = v
    end
    return cmd
end

function initArray3(f,x,v)
    local cmd = {}
    for c = 1, f do
    	cmd[c] = {x,v}
    end
    return cmd
end

function initArray4(f,x,v,m)
    local cmd = {}
    for c = 1, f do
    	cmd[c]={x,v,m}
    end
    return array
end

dofile("sys/lua/stargate/properties.lua")

print("Base functions initialized! Proceeding...")

------------------------------------
-- STARGATE NETWORK INITIAL SETUP --
------------------------------------

sg.init={}

sg.init.gateexists=initArray2(gatelimit,false)
sg.init.gatepos=initArray3(gatelimit,{0,0})
sg.init.gatepos2=initArray3(gatelimit,{0,0})
sg.init.dhdpos=initArray3(gatelimit,{0,0})
sg.init.currentsgid=1
sg.init.currentdhdid=1
sg.init.sgtype=initArray2(gatelimit,"")
sg.init.image=initArray2(gatelimit,0)
sg.init.dhdimage=initArray2(gatelimit,0)
sg.init.gateowner=initArray2(gatelimit,0)

function sg.init.gatespawn(id)
    menu(id,"Spawn a Stargate,SG-1,Atlantis,Universe")
end

function sg.init.removegate(gate)
    freeimage(sg.init.image[gate])
    freeimage(sg.init.dhdimage[gate])
    sg.init.gatepos[gate][1]=0
    sg.init.gatepos[gate][2]=0
    sg.init.gatepos[gate][3]=0
    sg.init.gatepos[gate][4]=0
    sg.init.gatepos[gate][5]=0
    sg.init.gatepos[gate][6]=0
    sg.init.dhdpos[gate][1]=0
    sg.init.dhdpos[gate][2]=0
    sg.init.dhdpos[gate][3]=0
    sg.init.dhdpos[gate][4]=0
    sg.init.dhdpos[gate][5]=0
    sg.init.dhdpos[gate][6]=0
    sg.init.gateexists[gate]=false
    sg.init.image[gate]=0
    sg.init.dhdimage[gate]=0
    sg.init.sgtype[gate]=""
	sg.init.gateowner[gate]=0
    sg.dial.sgaddress[gate]=""
    sg.dial.sgname[gate]=""
    sg.dial.EHsprite[gate]=0
    sg.dial.isopened[gate]=false
    sg.dial.isdialing[gate]=false
    sg.dial.openedto[gate]=0
    sg.dial.leadergate[gate]=false
end

function limitexceeded()
    if (sg.init.currentsgid>gatelimit and sg.init.currentdhdid>gatelimit) then
        return true
    else
        return false
    end
end

function NearBy(x,y,x2,y2,rx,ry)
	if (x>=x2-rx and x<=x2+rx and y>=y2-ry and y<=y2+ry) then
		return true
	end
	return false
end

addhook("startround","sg.init.cleanup")
function sg.init.cleanup()
    for gate=1,(sg.init.currentsgid-1) do
        freeimage(sg.init.image[gate])
        freeimage(sg.init.dhdimage[gate])
        sg.init.gatepos[gate][1]=0
        sg.init.gatepos[gate][2]=0
        sg.init.gatepos[gate][3]=0
        sg.init.gatepos[gate][4]=0
        sg.init.gatepos[gate][5]=0
        sg.init.gatepos[gate][6]=0
        sg.init.dhdpos[gate][1]=0
        sg.init.dhdpos[gate][2]=0
        sg.init.dhdpos[gate][3]=0
        sg.init.dhdpos[gate][4]=0
        sg.init.dhdpos[gate][5]=0
        sg.init.dhdpos[gate][6]=0
        sg.init.gateexists[gate]=false
        sg.init.image[gate]=0
        sg.init.dhdimage[gate]=0
        sg.init.sgtype[gate]=""
		sg.init.gateowner[gate]=0
        sg.dial.sgaddress[gate]=""
        sg.dial.sgname[gate]=""
        sg.dial.EHsprite[gate]=0
        sg.init.currentsgid=1
        sg.init.currentdhdid=1
        sg.dial.isopened[gate]=false
        sg.dial.isdialing[gate]=false
        sg.dial.openedto[gate]=0
        sg.dial.leadergate[gate]=false
    end
    if (gatelimit<0) then
        gatelimit=0
    end
    if (gatelimit>128) then
        gatelimit=128
    end
end

addhook("serveraction","sg.init.create")
function sg.init.create(id,action)
    if (action==1) then
		if not (adminsonly) then
			sg.init.gatespawn(id)
		else
			if (contains(admins,player(id,"usgn"))) then
				sg.init.gatespawn(id)
			else
				if (sg.modules.debug) then
					print("115110255Stargate debug: player "..player(id,"name").." has tried to open Stargate menu not being admin, denying")
				end
				msg2(id,"Only admins can spawn Stargates on this server!")
			end
		end
    end
	if (action==2) then
		if not (adminsonly) then
			sg.modules.extrasmenu(id)
		else
			if (contains(admins,player(id,"usgn"))) then
				sg.modules.extrasmenu(id)
			else
				if (sg.modules.debug) then
					print("115110255Stargate debug: player "..player(id,"name").." has tried to open Stargate extras menu not being admin, denying")
				end
				msg2(id,"Only admins can spawn extra modules entities on this server!")
			end
		end
	end
end

addhook("menu","sg.init.spawn")
function sg.init.spawn(id,menu,sel)
    if (menu=="Spawn a Stargate") then
        if not (limitexceeded()) then
			if (sel>0 and sel<=3) then
				if (sel==1) then
					sg.init.image[sg.init.currentsgid]=image("gfx/stargate.png",player(id,"x"),player(id,"y"),3)
					sg.init.dhdimage[sg.init.currentsgid]=image("gfx/dhd.png",player(id,"x"),player(id,"y")+112,0)
					msg2(id,"A new Milky Way-class Stargate was installed successfully!")
					sg.init.sgtype[sg.init.currentsgid]="Milky Way"
				end
				if (sel==2) then
					sg.init.image[sg.init.currentsgid]=image("gfx/stargate_atlantis.png",player(id,"x"),player(id,"y"),3)
					sg.init.dhdimage[sg.init.currentsgid]=image("gfx/dhd_atlantis.png",player(id,"x"),player(id,"y")+112,0)
					msg2(id,"A new Atlantis-class Stargate was installed successfully!")
					sg.init.sgtype[sg.init.currentsgid]="Atlantis"
				end
				if (sel==3) then
					sg.init.image[sg.init.currentsgid]=image("gfx/stargate_universe.png",player(id,"x"),player(id,"y"),3)
					sg.init.dhdimage[sg.init.currentsgid]=image("gfx/dhd_universe.png",player(id,"x"),player(id,"y")+112,0)
					msg2(id,"A new Universe-class Stargate was installed successfully!")
					sg.init.sgtype[sg.init.currentsgid]="Universe"
				end
				sg.init.gateexists[sg.init.currentsgid]=true
				sg.init.gatepos[sg.init.currentsgid][1]=player(id,"x")
				sg.init.gatepos[sg.init.currentsgid][2]=player(id,"y")+48
				sg.init.dhdpos[sg.init.currentsgid][1]=player(id,"x")
				sg.init.dhdpos[sg.init.currentsgid][2]=player(id,"y")+112
				sg.init.gatepos[sg.init.currentsgid][3]=math.floor(sg.init.gatepos[sg.init.currentsgid][1]/32)
				sg.init.gatepos[sg.init.currentsgid][4]=math.floor(sg.init.gatepos[sg.init.currentsgid][2]/32)
				sg.init.dhdpos[sg.init.currentsgid][3]=math.floor(sg.init.dhdpos[sg.init.currentsgid][1]/32)
				sg.init.dhdpos[sg.init.currentsgid][4]=math.floor(sg.init.dhdpos[sg.init.currentsgid][2]/32)
				sg.init.gatepos[sg.init.currentsgid][5]=player(id,"x")
				sg.init.gatepos[sg.init.currentsgid][6]=player(id,"y")
				sg.init.gateowner[sg.init.currentsgid]=id
				sg.init.currentsgid=sg.init.currentsgid+1
				sg.init.currentdhdid=sg.init.currentdhdid+1
				if (sg.modules.debug) then
					print("115110255Stargate debug: a new Stargate has been spawned with ID "..(sg.init.currentsgid-1)..", on position ("..sg.init.gatepos[sg.init.currentsgid-1][5]..";"..sg.init.gatepos[sg.init.currentsgid-1][6].."), type - "..sg.init.sgtype[sg.init.currentsgid-1])
				end
			end
        else
            msg2(id,"Server Stargate limit has been exceeded! You can't spawn any more gates!")
        end
    end
end

function sg.init.exists(gate)
    if sg.init.gateexists[gate]==true then
        return true
    else
        return false
    end
end

addhook("spawn","sg.init.help")
function sg.init.help(id)
    msg2(id,"Write !sghelp for basic HUD help.")
end

function hudtxt2(id,idt,color,text,x,y)
    local toprint=(""..color.." "..text)
    parse('hudtxt2 '..id..' '..idt..' "'..toprint..'" '..x.." "..y)
end

print("Stargate init setup initialized! Proceeding...")

----------------------------------------
-- STARGATE NETWORK DIALING ALGORITHM --
---------------------------------------- 

sg.dial={}

sg.dial.sgaddress=initArray2(gatelimit,"")
sg.dial.sgname=initArray2(gatelimit,"N/A")
sg.dial.idstack=initArray2(32,0)
sg.dial.setaddressmode=initArray2(32,false)
sg.dial.setnamemode=initArray2(32,false)
sg.dial.gateinitialized=initArray2(gatelimit,false)
sg.dial.leadergate=initArray2(gatelimit,false)
sg.dial.isdialing=initArray2(gatelimit,false)
sg.dial.isopened=initArray2(gatelimit,false)
sg.dial.openedto=initArray2(gatelimit,0)
sg.dial.EHsprite=initArray2(gatelimit,0)
sg.dial.isentering=initArray2(32,false)
sg.dial.ismentering=initArray2(32,false)

function getSound(gate)
	if (sg.init.sgtype[gate]=="Milky Way") then
		if (sound==1) then
			return "stargate/chevron_dhd.ogg"
		end
	end
	if (sg.init.sgtype[gate]=="Atlantis") then
		if (sound==1) then
			return "stargate/atl_chevron.ogg"
		end
	end
	if (sg.init.sgtype[gate]=="Universe") then
		if (sound==1) then
			return "stargate/sgu_chevron1.ogg"
		end
	end
end

sg.dial.acp=initArray3(7,{0,0})

sg.dial.acp[1][1]=190
sg.dial.acp[1][2]=215

sg.dial.acp[2][1]=213
sg.dial.acp[2][2]=257

sg.dial.acp[3][1]=205
sg.dial.acp[3][2]=307

sg.dial.acp[4][1]=81
sg.dial.acp[4][2]=307

sg.dial.acp[5][1]=73
sg.dial.acp[5][2]=257

sg.dial.acp[6][1]=97
sg.dial.acp[6][2]=215

sg.dial.acp[7][1]=143
sg.dial.acp[7][2]=200

sg.dial.chevron=initArray3(gatelimit,{0,0})

function chevronCreate(gate,c)
	if (sg.init.sgtype[gate]=="Atlantis") then
		if (c==1) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+44,sg.init.gatepos[gate][6]-55,3)
		elseif (c==2) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+69,sg.init.gatepos[gate][6]-12,3)
		elseif (c==3) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+61,sg.init.gatepos[gate][6]+37,3)
		elseif (c==4) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-61,sg.init.gatepos[gate][6]+37,3)
		elseif (c==5) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-69,sg.init.gatepos[gate][6]-12,3)
		elseif (c==6) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-44,sg.init.gatepos[gate][6]-55,3)
		elseif (c==7) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6]-70,3)
		end
		imageblend(sg.dial.chevron[gate][c],1)
		imagecolor(sg.dial.chevron[gate][c],70,70,255)
	end
	if (sg.init.sgtype[gate]=="Milky Way") then
		if (c==1) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+44,sg.init.gatepos[gate][6]-55,3)
		elseif (c==2) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+69,sg.init.gatepos[gate][6]-12,3)
		elseif (c==3) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+61,sg.init.gatepos[gate][6]+37,3)
		elseif (c==4) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-61,sg.init.gatepos[gate][6]+37,3)
		elseif (c==5) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-69,sg.init.gatepos[gate][6]-12,3)
		elseif (c==6) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-44,sg.init.gatepos[gate][6]-55,3)
		elseif (c==7) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6]-70,3)
		end
		imageblend(sg.dial.chevron[gate][c],1)
		imagecolor(sg.dial.chevron[gate][c],255,235,0)
	end
	if (sg.init.sgtype[gate]=="Universe") then
		if (c==1) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+44,sg.init.gatepos[gate][6]-55,3)
		elseif (c==2) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+69,sg.init.gatepos[gate][6]-12,3)
		elseif (c==3) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]+61,sg.init.gatepos[gate][6]+37,3)
		elseif (c==4) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-61,sg.init.gatepos[gate][6]+37,3)
		elseif (c==5) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-69,sg.init.gatepos[gate][6]-12,3)
		elseif (c==6) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5]-44,sg.init.gatepos[gate][6]-55,3)
		elseif (c==7) then
			sg.dial.chevron[gate][c]=image("gfx/sprites/flare1.bmp",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6]-70,3)
		end
		imageblend(sg.dial.chevron[gate][c],1)
		imagecolor(sg.dial.chevron[gate][c],255,255,255)
	end
end

function chevronRemove(gate,c)
	freeimage(sg.dial.chevron[gate][c])
	sg.dial.chevron[gate][c]=0
end

function checkDelay(gate)
	if (sg.init.sgtype[gate]=="Milky Way") then
		if (sg.dial.leadergate[gate]) then
			return 7000
		else
			return 6000
		end
	elseif (sg.init.sgtype[gate]=="Atlantis") then
		if (sg.dial.leadergate[gate]) then
			return 6500
		else
			return 6000
		end
	else
		return 6000
	end
end

function chevronSequence(gate,mode)
	chevronCreate(gate,1)
	timer(1000,"parse","lua chevronCreate("..gate..",2)")
	timer(2000,"parse","lua chevronCreate("..gate..",3)")
	timer(3000,"parse","lua chevronCreate("..gate..",4)")
	timer(4000,"parse","lua chevronCreate("..gate..",5)")
	timer(5000,"parse","lua chevronCreate("..gate..",6)")
	if (mode==0) then
		timer(6000,"parse","lua chevronCreate("..gate..",7)")
	elseif (mode==1) then
		if (sg.init.sgtype[gate]=="Milky Way") then
			timer(7000,"parse","lua chevronCreate("..gate..",7)")
		elseif (sg.init.sgtype[gate]=="Atlantis") then
			timer(6500,"parse","lua chevronCreate("..gate..",7)")
		else
			timer(6000,"parse","lua chevronCreate("..gate..",7)")
		end
	end
end

function dialSlowSequence(gate,gate2)
	sg.dial.isdialing[gate]=true
	sg.dial.isdialing[gate2]=true
	sg.dial.leadergate[gate]=true
	sg.dial.leadergate[gate2]=false
	sg.dial.openedto[gate]=gate2
	sg.dial.openedto[gate2]=gate
	--1--
	sound3("stargate/roll.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
	timer(2000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(3000,"parse","lua chevronCreate("..gate..",7)")
	timer(4000,"parse","lua chevronCreate("..gate..",1)")
	timer(4000,"parse","lua chevronRemove("..gate..",7)")
	--2--
	timer(5000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(7000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(8000,"parse","lua chevronCreate("..gate..",7)")
	timer(9000,"parse","lua chevronCreate("..gate..",2)")
	timer(9000,"parse","lua chevronRemove("..gate..",7)")
	--3--
	timer(10000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(12000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(13000,"parse","lua chevronCreate("..gate..",7)")
	timer(14000,"parse","lua chevronCreate("..gate..",3)")
	timer(14000,"parse","lua chevronRemove("..gate..",7)")
	--4--
	timer(15000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(17000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(18000,"parse","lua chevronCreate("..gate..",7)")
	timer(19000,"parse","lua chevronCreate("..gate..",4)")
	timer(19000,"parse","lua chevronRemove("..gate..",7)")
	--5--
	timer(20000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(22000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(23000,"parse","lua chevronCreate("..gate..",7)")
	timer(24000,"parse","lua chevronCreate("..gate..",5)")
	timer(24000,"parse","lua chevronRemove("..gate..",7)")
	--6--
	timer(25000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(27000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(27000,"parse","lua chevronSequence("..gate2..",1)")
	timer(27000,"parse","lua soundSequence("..gate2..")")
	timer(28000,"parse","lua chevronCreate("..gate..",7)")
	timer(29000,"parse","lua chevronCreate("..gate..",6)")
	timer(29000,"parse","lua chevronRemove("..gate..",7)")
	--7--
	timer(30000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(32000,"parse","lua sound3(\"stargate/lock.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(33000,"parse","lua chevronCreate("..gate..",7)")
	timer(34000,"parse","lua sound3(\"stargate/open.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(34000,"parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..",1)")
	timer(34000,"parse","lua sg.dial.EHsprite["..gate2.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate2][5]..","..sg.init.gatepos[gate2][6]..",1)")
	timer(34000,"parse","lua sg.dial.isopened["..gate.."]=true")
	timer(34000,"parse","lua sg.dial.isopened["..gate2.."]=true")
	timer(34000,"parse","lua sg.dial.isdialing["..gate.."]=false")
	timer(34000,"parse","lua sg.dial.isdialing["..gate2.."]=false")
end

--[[ old
function dialSlowSequence(gate,gate2)
	sg.dial.isdialing[gate]=true
	sg.dial.isdialing[gate2]=true
	sg.dial.leadergate[gate]=true
	sg.dial.leadergate[gate2]=false
	sg.dial.openedto[gate]=gate2
	sg.dial.openedto[gate2]=gate
	--1--
	sound3("stargate/roll.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
	timer(2000,"parse","lua chevronCreate("..gate..",7)")
	timer(2000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(3000,"parse","lua chevronCreate("..gate..",1)")
	timer(3000,"parse","lua chevronRemove("..gate..",7)")
	--2--
	timer(5000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(7000,"parse","lua chevronCreate("..gate..",7)")
	timer(7000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(8000,"parse","lua chevronCreate("..gate..",2)")
	timer(8000,"parse","lua chevronRemove("..gate..",7)")
	--3--
	timer(10000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(12000,"parse","lua chevronCreate("..gate..",7)")
	timer(12000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(13000,"parse","lua chevronCreate("..gate..",3)")
	timer(13000,"parse","lua chevronRemove("..gate..",7)")
	--4--
	timer(15000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(17000,"parse","lua chevronCreate("..gate..",7)")
	timer(17000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(18000,"parse","lua chevronCreate("..gate..",4)")
	timer(18000,"parse","lua chevronRemove("..gate..",7)")
	--5--
	timer(20000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(22000,"parse","lua chevronCreate("..gate..",7)")
	timer(22000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(23000,"parse","lua chevronCreate("..gate..",5)")
	timer(23000,"parse","lua chevronRemove("..gate..",7)")
	--6--
	timer(25000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(26000,"parse","lua chevronSequence("..gate2..",1)")
	timer(26000,"parse","lua soundSequence("..gate2..")")
	timer(27000,"parse","lua chevronCreate("..gate..",7)")
	timer(27000,"parse","lua sound3(\"stargate/chevron_2.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(28000,"parse","lua chevronCreate("..gate..",6)")
	timer(28000,"parse","lua chevronRemove("..gate..",7)")
	--7--
	timer(30000,"parse","lua sound3(\"stargate/roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(32000,"parse","lua sound3(\"stargate/lock.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(32000,"parse","lua chevronCreate("..gate..",7)")
	timer(33000,"parse","lua sound3(\"stargate/open.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	timer(33000,"parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..",1)")
	timer(33000,"parse","lua sg.dial.EHsprite["..gate2.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate2][5]..","..sg.init.gatepos[gate2][6]..",1)")
	timer(33000,"parse","lua sg.dial.isopened["..gate.."]=true")
	timer(33000,"parse","lua sg.dial.isopened["..gate2.."]=true")
	timer(33000,"parse","lua sg.dial.isdialing["..gate.."]=false")
	timer(33000,"parse","lua sg.dial.isdialing["..gate2.."]=false")
end
]]

function soundSequence(gate)
	if (sg.init.sgtype[gate]=="Milky Way") then
		sound3("stargate/chevron_incoming.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
		sound3("stargate/roll_long.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
		timer(1000,"parse","lua sound3(\"stargate/chevron_incoming.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)",5)
		timer(7000,"parse","lua sound3(\"stargate/chevron_incoming.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
		timer(7150,"parse","lua sound3(\"stargate/open.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	end
	if (sg.init.sgtype[gate]=="Atlantis") then
		sound3("stargate/atl_roll_start.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
		timer(100,"parse","lua sound3(\"stargate/chevron_atlantis_incoming.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
		timer(1000,"parse","lua sound3(\"stargate/chevron_atlantis_incoming.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)",5)
		timer(6500,"parse","lua sound3(\"stargate/chevron_lock_atlantis_incoming.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
		timer(7100,"parse","lua sound3(\"stargate/atl_open.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	end
	if (sg.init.sgtype[gate]=="Universe") then
		sound3("stargate/sgu_roll.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
		sound3("stargate/sgu_chevron1.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
		timer(1000,"parse","lua sound3(\"stargate/sgu_chevron1.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)",6)
		timer(4000,"parse","lua sound3(\"stargate/sgu_roll.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
		timer(7000,"parse","lua sound3(\"stargate/sgu_open.ogg\",sg.init.gatepos["..gate.."][1],sg.init.gatepos["..gate.."][2],256,256)")
	end
end

function sg.dial.dial(id,gate1,gate2)
    if (sg.init.gateexists[gate2]==true and sg.dial.isopened[gate2]==false and sg.dial.isopened[gate1]==false and sg.dial.gateinitialized[gate2]==true and gate1~=gate2 and not sg.dial.isdialing[gate1] and not sg.dial.isdialing[gate2]) then
        sg.dial.isdialing[gate1]=true
		sg.dial.isdialing[gate2]=true
		sg.dial.leadergate[gate1]=true
		sg.dial.leadergate[gate2]=false
		sg.dial.openedto[gate1]=gate2
		sg.dial.openedto[gate2]=gate1
		chevronSequence(gate1)
		if (sg.init.sgtype[gate1]=="Milky Way") then
			sound3("stargate/roll_long.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			sound3("stargate/chevron_dhd.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			timer(1000,"parse","lua sound3(\"stargate/chevron_dhd.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)",5)
			timer(6000,"parse","lua sound3(\"stargate/chevron_lock.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
			timer(7000,"parse","lua sound3(\"stargate/open.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
			chevronSequence(gate2)
        elseif (sg.init.sgtype[gate1]=="Atlantis") then
			sound3("stargate/atl_roll.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			sound3("stargate/atl_chevron.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			timer(1000,"parse","lua sound3(\"stargate/atl_chevron.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)",6)
			timer(6000,"parse","lua sound3(\"stargate/atl_open.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
			chevronSequence(gate2)
        elseif (sg.init.sgtype[gate1]=="Universe") then
			sound3("stargate/sgu_roll.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			sound3("stargate/sgu_chevron1.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			timer(1000,"parse","lua sound3(\"stargate/sgu_chevron1.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)",6)
			timer(4000,"parse","lua sound3(\"stargate/sgu_roll.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
            timer(7000,"parse","lua sound3(\"stargate/sgu_open.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
			chevronSequence(gate2)
        end
		timer(7000,"parse","lua sg.dial.EHsprite["..gate1.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate1][5]..","..sg.init.gatepos[gate1][6]..",1)")
        timer(7000,"parse","lua sg.dial.EHsprite["..gate2.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate2][5]..","..sg.init.gatepos[gate2][6]..",1)")
		timer(7000,"parse","lua sg.dial.isopened["..gate1.."]=true")
		timer(7000,"parse","lua sg.dial.isopened["..gate2.."]=true")
		timer(7000,"parse","lua sg.dial.isdialing["..gate1.."]=false")
		timer(7000,"parse","lua sg.dial.isdialing["..gate2.."]=false")
    end
end

function sg.dial.close(id,gate)
    if (sg.dial.isopened[gate]==true) then
        sound3("stargate/gate_close.ogg",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6],256,256)
		sound3("stargate/gate_close.ogg",sg.init.gatepos[sg.dial.openedto[gate]][5],sg.init.gatepos[sg.dial.openedto[gate]][6],256,256)
        timer(1000,"parse","lua freeimage(sg.dial.EHsprite["..gate.."])")
        timer(1000,"parse","lua freeimage(sg.dial.EHsprite["..sg.dial.openedto[gate].."])")
		timer(1000,"parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/dewormhole1.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..",1)")
		timer(1000,"parse","lua sg.dial.EHsprite["..sg.dial.openedto[gate].."]=image(\"gfx/dewormhole1.png\","..sg.init.gatepos[sg.dial.openedto[gate]][5]..","..sg.init.gatepos[sg.dial.openedto[gate]][6]..",1)")
		timer(2000,"parse","lua freeimage(sg.dial.EHsprite["..gate.."])")
        timer(2000,"parse","lua freeimage(sg.dial.EHsprite["..sg.dial.openedto[gate].."])")
		timer(2000,"parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/dewormhole.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..",1)")
		timer(2000,"parse","lua sg.dial.EHsprite["..sg.dial.openedto[gate].."]=image(\"gfx/dewormhole.png\","..sg.init.gatepos[sg.dial.openedto[gate]][5]..","..sg.init.gatepos[sg.dial.openedto[gate]][6]..",1)")
        timer(3000,"parse","lua freeimage(sg.dial.EHsprite["..gate.."])")
		timer(3000,"parse","lua freeimage(sg.dial.EHsprite["..sg.dial.openedto[gate].."])")
		for c=1,7 do
			--if (sg.init.sgtype[gate]~="Universe") then -- universe gate doesn't have chevron lights
				timer(2000,"parse","lua freeimage("..sg.dial.chevron[gate][c]..")")
				timer(2000,"parse","lua sg.dial.chevron["..gate.."]["..c.."]=0")
			--end
			--if (sg.init.sgtype[sg.dial.openedto[gate]]~="Universe") then -- universe gate doesn't have chevron lights, again
				timer(2000,"parse","lua freeimage("..sg.dial.chevron[sg.dial.openedto[gate]][c]..")")
				timer(2000,"parse","lua sg.dial.chevron["..sg.dial.openedto[gate].."]["..c.."]=0")
			--end
		end
        sg.dial.isopened[gate]=false
        sg.dial.isopened[sg.dial.openedto[gate]]=false
        sg.dial.openedto[gate]=0
    end
end

function sg.dial.abort(id,gate)
    if (sg.dial.isdialing[gate]==true) then
        if (sg.init.gatetype=="Milky Way") then
            parse("sv_sound2 "..id.." \"stargate/dial_fail.ogg\"")
            freetimer("parse","sv_sound2 "..id.." \"stargate/chevron.ogg\"")
            freetimer("parse","sv_sound2 "..id.." \"stargate/chevron_lock.ogg\"")
            freetimer("parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..",1)")
            freetimer("parse","lua sg.dial.EHsprite["..sg.dial.openedto[gate].."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[sg.dial.openedto[gate]][5]..","..sg.init.gatepos[sg.dial.openedto[gate]][6]..",1)")
            freetimer("parse","sv_sound2 "..id.." \"stargate/open.ogg\"")
            freetimer("parse","sg.dial.isopened["..gate.."]=true")
            freetimer("parse","sg.dial.isopened["..sg.dial.openedto[gate].."]=true")
            sg.dial.isdialing[gate]=false
        elseif (sg.init.gatetype=="Atlantis") then
            parse("sv_sound2 "..id.." \"stargate/dial_fail_atlantis.ogg\"")
            freetimer("parse","sv_sound2 "..id.." \"stargate/atl_chevron.ogg\"")
            freetimer("parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..",1)")
            freetimer("parse","lua sg.dial.EHsprite["..sg.dial.openedto[gate].."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[sg.dial.openedto[gate]][5]..","..sg.init.gatepos[sg.dial.openedto[gate]][6]..",1)")
            freetimer("parse","sv_sound2 "..id.." \"stargate/atl_open.ogg\"")
            freetimer("parse","sg.dial.isopened["..gate.."]=true")
            freetimer("parse","sg.dial.isopened["..sg.dial.openedto[gate].."]=true")
            sg.dial.isdialing[gate]=false
        elseif (sg.init.gatetype=="Universe") then
            freetimer("parse","sv_sound2 "..id.." \"stargate/sgu_chevron1.ogg\"")
            freetimer("parse","sv_sound2 "..id.." \"stargate/sgu_lock.ogg\"")
            freetimer("parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..",1)")
            freetimer("parse","lua sg.dial.EHsprite["..sg.dial.openedto[gate].."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[sg.dial.openedto[gate]][5]..","..sg.init.gatepos[sg.dial.openedto[gate]][6]..",1)")
            freetimer("parse","sv_sound2 "..id.." \"stargate/sgu_open.ogg\"")
            freetimer("parse","sg.dial.isopened["..gate.."]=true")
            freetimer("parse","sg.dial.isopened["..sg.dial.openedto[gate].."]=true")
            sg.dial.isdialing[gate]=false
        end
    end
end

function sg.dial.menustat(gate)
    if (sg.init.exists(gate)==true and sg.dial.gateinitialized[gate]) then
        return sg.dial.sgaddress[gate].." - "..sg.dial.sgname[gate]
    else
        return ","
    end
end

function sg.dial.gatemenu(id,gate)
	if (id==sg.init.gateowner[gate]) then
		menu(id,"Gate Menu,Set Address,Set Name,Dial Manually,Remove")
		sg.dial.idstack[id]=gate
	else
		menu(id,"Gate Menu,,,Dial Manually")
		sg.dial.idstack[id]=gate
	end
end

function sg.dial.gatedial(id,gate,page)
    if (sg.dial.isopened[gate]==true) then
        menu(id,"Dialing Menu (Gate Opened),Close")
        sg.dial.idstack[id]=gate
    else
        menu(id,"Dialing Menu,Dial a gate")
        sg.dial.idstack[id]=gate
    end
    if (sg.dial.isdialing[gate]==true) then
        menu(id,"Dialing Menu,")
    end
end

addhook("use","sg.dial.address")
function sg.dial.address(id,e,d,x,y)
    for gate=1,sg.init.currentsgid do
        if (player(id,"tilex")==sg.init.gatepos[gate][3]) and (player(id,"tiley")==sg.init.gatepos[gate][4]) then
            sg.dial.gatemenu(id,gate)
        end
        if (player(id,"tilex")==sg.init.dhdpos[gate][3] and player(id,"tiley")==sg.init.dhdpos[gate][4]) then
            sg.dial.gatedial(id,gate,1)
        end
    end
end

addhook("menu","sg.dial.menuselect")
function sg.dial.menuselect(id,menu,sel)
    if (menu=="Gate Menu") then
        if (sel==1) then
            sg.dial.setaddressmode[id]=true
            msg2(id,"Please write a 6-symbol address in the chat.")
        end
        if (sel==2) then
            sg.dial.setnamemode[id]=true
            msg2(id,"Write a name for the gate used for easier search.")
        end
		if (sel==3) then
            sg.dial.ismentering[id]=true
            msg2(id,"Enter a gate address in chat to dial it.")
        end
        if (sel==4) then
            sg.init.removegate(sg.dial.idstack[id])
			sg.dial.idstack[id]=0
        end
    end
    if (menu=="Dialing Menu (Gate Opened)") then
        if (sel==1) then
            sg.dial.close(id,sg.dial.idstack[id])
        end
    end
    if (menu=="Dialing Menu (Gate Dialing)") then
        if (sel==1) then
            sg.dial.abort(id,sg.dial.idstack[id])
        end
    end
    if (menu=="Dialing Menu") then
        if (sel==1) then
            sg.dial.isentering[id]=true
            msg2(id,"Enter a gate address in chat to dial it.")
        end
    end
end

function checkForName(sgid,s)
	for sgg=1,sg.init.currentsgid do
		if (sgg~=sgid) then
			if (sg.dial.sgaddress[sgg]~=s) then
				return true
			else
				return false
			end
		end
	end
end

function sound3(snd,x,y,rx,ry)
	for id=1,32 do
		if (player(id,"exists") and player(id,"x")>=x-rx and player(id,"x")<=x+rx and player(id,"y")>=y-ry and player(id,"y")<=y+ry and snd~=nil) then
			parse("sv_sound2 "..id.." \""..snd.."\"")
		end
	end
end

print("Stargate dialing module initialized! Proceeding...")

-----------------------------------
-- STARGATE TRAVELLING FUNCTIONS --
-----------------------------------

sg.travel={}

addhook("movetile","sg.travel.through")
function sg.travel.through(id,x,y)
    for gate=1,sg.init.currentsgid do
        if (sg.dial.isopened[gate] and sg.dial.leadergate[gate]) then
            if (x==sg.init.gatepos[gate][3] and y==sg.init.gatepos[gate][4]) then
                freetimer("parse","lua sg.dial.close("..id..","..gate..")")
                parse("setpos "..id.." "..sg.init.gatepos[sg.dial.openedto[gate]][1].." "..sg.init.gatepos[sg.dial.openedto[gate]][2]+96)
				sound3("stargate/teleport_8.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
				sound3("stargate/teleport_8.ogg",sg.init.gatepos[sg.dial.openedto[gate]][1],sg.init.gatepos[sg.dial.openedto[gate]][2],256,256)
                timer(3000,"parse","lua sg.dial.close("..id..","..gate..")")
            end
        elseif (sg.dial.isopened[gate] and sg.dial.leadergate[gate]==false) then
            if (x==sg.init.gatepos[gate][3] and y==sg.init.gatepos[gate][4]) then
                parse("customkill 0 Stargate "..id) --to kill them dumbasses trying to go thru the destination gate. stargates are one-way only!
				sound3("stargate/teleport_8.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
				sound3("stargate/teleport_8.ogg",sg.init.gatepos[sg.dial.openedto[gate]][1],sg.init.gatepos[sg.dial.openedto[gate]][2],256,256)
            end
        end
    end
end

print("Stargate travelling module initialized! Proceeding...")

---------------------------------
-- STARGATE ADDITIONAL MODULES --
---------------------------------
dofile("sys/lua/stargate/modules.lua")

print("Stargate additional modules initialized! Proceeding...")

------------------------------------
-- STARGATE GATESPAWNER FUNCTIONS --
------------------------------------

sg.gatespawn={}

function sg.gatespawn.create(id,type,posx,posy,dhdx,dhdy,address,name)
    local px=math.floor((posx*32)+16)
    local py=math.floor((posy*32)+16)
    local dhdpx=math.floor((dhdx*32)+16)
    local dhdpy=math.floor((dhdy*32)+16)
    if (type=="Milky Way") then
        print("A new Milky Way-class gate is being initialized!")
        sg.init.image[sg.init.currentsgid]=image("gfx/stargate.png",px,py,3)
        sg.init.dhdimage[sg.init.currentsgid]=image("gfx/dhd.png",dhdpx,dhdpy,0)
        print("Creating sprite... Done.")
        sg.init.gateexists[sg.init.currentsgid]=true
        sg.init.gatepos[sg.init.currentsgid][1]=px
        sg.init.gatepos[sg.init.currentsgid][2]=py+48
        sg.init.dhdpos[sg.init.currentsgid][1]=dhdpx
        sg.init.dhdpos[sg.init.currentsgid][2]=dhdpy
        sg.init.gatepos[sg.init.currentsgid][3]=math.floor(sg.init.gatepos[sg.init.currentsgid][1]/32)
        sg.init.gatepos[sg.init.currentsgid][4]=math.floor(sg.init.gatepos[sg.init.currentsgid][2]/32)
        sg.init.dhdpos[sg.init.currentsgid][3]=dhdx
        sg.init.dhdpos[sg.init.currentsgid][4]=dhdy
        sg.init.gatepos[sg.init.currentsgid][5]=px
        sg.init.gatepos[sg.init.currentsgid][6]=py
        sg.init.sgtype[sg.init.currentsgid]="Milky Way"
        sg.dial.gateinitialized[sg.init.currentsgid]=true
        sg.dial.sgaddress[sg.init.currentsgid]=address
        print("Setting an address... Set: "..address)
        if (name~=nil) then
            sg.dial.sgname[sg.init.currentsgid]=name
            print("Setting a name... Set: "..name)
        end
        print("A new Milky Way-class gate has been initialized!")
        sg.init.currentsgid=sg.init.currentsgid+1
        sg.init.currentdhdid=sg.init.currentdhdid+1
    elseif (type=="Atlantis") then
        print("A new Atlantis-class gate is being initialized!")
        sg.init.image[sg.init.currentsgid]=image("gfx/stargate_atlantis.png",px,py,3)
        sg.init.dhdimage[sg.init.currentsgid]=image("gfx/dhd_atlantis.png",dhdpx,dhdpy,0)
        print("Creating sprite... Done.")
        sg.init.gateexists[sg.init.currentsgid]=true
        sg.init.gatepos[sg.init.currentsgid][1]=px
        sg.init.gatepos[sg.init.currentsgid][2]=py+48
        sg.init.dhdpos[sg.init.currentsgid][1]=dhdpx
        sg.init.dhdpos[sg.init.currentsgid][2]=dhdpy
        sg.init.gatepos[sg.init.currentsgid][3]=math.floor(sg.init.gatepos[sg.init.currentsgid][1]/32)
        sg.init.gatepos[sg.init.currentsgid][4]=math.floor(sg.init.gatepos[sg.init.currentsgid][2]/32)
        sg.init.dhdpos[sg.init.currentsgid][3]=dhdx
        sg.init.dhdpos[sg.init.currentsgid][4]=dhdy
        sg.init.gatepos[sg.init.currentsgid][5]=px
        sg.init.gatepos[sg.init.currentsgid][6]=py
        sg.init.sgtype[sg.init.currentsgid]="Atlantis"
        sg.dial.gateinitialized[sg.init.currentsgid]=true
        sg.dial.sgaddress[sg.init.currentsgid]=address
        print("Setting an address... Set: "..address)
        if (name~=nil) then
            sg.dial.sgname[sg.init.currentsgid]=name
            print("Setting a name... Set: "..name)
        end
        print("A new Atlantis-class gate has been initialized!")
        sg.init.currentsgid=sg.init.currentsgid+1
        sg.init.currentdhdid=sg.init.currentdhdid+1
    elseif (type=="Universe") then
        print("A new Universe-class gate is being initialized!")
        sg.init.image[sg.init.currentsgid]=image("gfx/stargate_universe.png",px,py,3)
        sg.init.dhdimage[sg.init.currentsgid]=image("gfx/dhd_universe.png",dhdpx,dhdpy,0)
        print("Creating sprite... Done.")
        sg.init.gateexists[sg.init.currentsgid]=true
        sg.init.gatepos[sg.init.currentsgid][1]=px
        sg.init.gatepos[sg.init.currentsgid][2]=py+48
        sg.init.dhdpos[sg.init.currentsgid][1]=dhdpx
        sg.init.dhdpos[sg.init.currentsgid][2]=dhdpy
        sg.init.gatepos[sg.init.currentsgid][3]=math.floor(sg.init.gatepos[sg.init.currentsgid][1]/32)
        sg.init.gatepos[sg.init.currentsgid][4]=math.floor(sg.init.gatepos[sg.init.currentsgid][2]/32)
        sg.init.dhdpos[sg.init.currentsgid][3]=dhdx
        sg.init.dhdpos[sg.init.currentsgid][4]=dhdy
        sg.init.gatepos[sg.init.currentsgid][5]=px
        sg.init.gatepos[sg.init.currentsgid][6]=py
        sg.init.sgtype[sg.init.currentsgid]="Universe"
        sg.dial.gateinitialized[sg.init.currentsgid]=true
        sg.dial.sgaddress[sg.init.currentsgid]=address
        print("Setting an address... Set: "..address)
        if (name~=nil) then
            sg.dial.sgname[sg.init.currentsgid]=name
            print("Setting a name... Set: "..name)
        end
        print("A new Universe-class gate has been initialized!")
        sg.init.currentsgid=sg.init.currentsgid+1
        sg.init.currentdhdid=sg.init.currentdhdid+1
    end
end

function sg.modules.rings.speccreate(ply,x,y,ad,inv)
	if (sg.modules.rings.currentringid<=sg.modules.rings.limit and sg.modules.rings.currentringid>=0) then
		if (sg.modules.debug) then
			print("115110255Stargate debug: gatespawner has spawned ring platform #"..sg.modules.rings.currentringid)
		end
		if (inv==nil) then
			sg.modules.rings.base[sg.modules.rings.currentringid]=image("gfx/goauld_ringbase.png",(x*32)+16,(y*32)+16,0)
			if (sg.modules.debug) then
				print("115110255Stargate debug: ring platform #"..sg.modules.rings.currentringid.." - image created")
			end
		elseif (inv==true) then
			sg.modules.rings.invisible[sg.modules.rings.currentringid]=true
			if (sg.modules.debug) then
				print("115110255Stargate debug: ring platform #"..sg.modules.rings.currentringid.." - invisible mode, ignoring image")
			end
		end
		sg.modules.rings.pos[sg.modules.rings.currentringid][1]=(x*32)+16
		if (sg.modules.debug) then
			print("115110255Stargate debug: ring platform #"..sg.modules.rings.currentringid.." - x position set to "..(x*32)+16)
		end
		sg.modules.rings.pos[sg.modules.rings.currentringid][2]=(y*32)+16
		if (sg.modules.debug) then
			print("115110255Stargate debug: ring platform #"..sg.modules.rings.currentringid.." - y position set to "..(y*32)+16)
		end
		sg.modules.rings.pos[sg.modules.rings.currentringid][3]=x
		if (sg.modules.debug) then
			print("115110255Stargate debug: ring platform #"..sg.modules.rings.currentringid.." - tilex position set to "..x)
		end
		sg.modules.rings.pos[sg.modules.rings.currentringid][4]=y
		if (sg.modules.debug) then
			print("115110255Stargate debug: ring platform #"..sg.modules.rings.currentringid.." - tiley position set to "..y)
		end
		sg.modules.rings.owner[sg.modules.rings.currentringid]=ply
		if (sg.modules.debug) then
			print("115110255Stargate debug: ring platform #"..sg.modules.rings.currentringid.." - owner set to "..ply)
		end
		sg.modules.rings.address[sg.modules.rings.currentringid]=ad:sub(1,10)
		if (sg.modules.debug) then
			print("115110255Stargate debug: ring platform #"..sg.modules.rings.currentringid.." - address set to "..ad)
		end
		if (sg.modules.debug) then
			print("115110255Stargate debug: ring base #"..sg.modules.rings.currentringid.." installed successfully")
		end
		sg.modules.rings.currentringid=sg.modules.rings.currentringid+1
		if (sg.modules.rings.currentringid>sg.modules.rings.limit) then
			print("255000000Stargate error: sg.modules.rings.currentringid can not be more than "..sg.modules.rings.limit..", aborting")
		end
	end
end

if (execute_gatespawner) then
	local gatespawner=assert(io.open("sys/lua/stargate/gatespawner/"..game("sv_map")..".lua","r"))
	if (gatespawner~=nil) then
		dofile("sys/lua/stargate/gatespawner/"..game("sv_map")..".lua")
	end
    if (GATES~=nil and GATES[1]~=nil) then -- yeah always check twice, if possible - thrice (like in this case), what if I created an empty table, huh? HUH? There MUST be at least one gate in the gatespawner file!
        print("Gate spawner initialized!")
        for gate=1,#GATES do
            sg.gatespawn.create(GATES[gate].id,GATES[gate].type,GATES[gate].x,GATES[gate].y,GATES[gate].dhdx,GATES[gate].dhdy,GATES[gate].address,GATES[gate].name)
        end
    else
        print("Gate spawner not found!")
		print("Proceeding...")
    end
else
    print("Gate spawner module not active - activate if needed!")
    print("Proceeding...")
end

function ringspawnercheck()
	if (execute_gatespawner) then
		if (RINGTRANS~=nil and RINGTRANS[1]~=nil) then 
			print("Ring spawner initialized!")
			for ring=1,#RINGTRANS do
				sg.modules.rings.speccreate(0,RINGTRANS[ring].x,RINGTRANS[ring].y,RINGTRANS[ring].address,RINGTRANS[ring].invis)
			end
		else
			print("Ring spawner not found!")
			print("Proceeding...")
		end
	end
end

function irisspawnercheck()
	if (execute_gatespawner) then
		if (IRISS~=nil and IRISS[1]~=nil) then 
			print("Iris spawner initialized!")
			for iris=1,#IRISS do
				sg.modules.iris.screate(0,IRISS[iris].gate,IRISS[iris].type,IRISS[iris].toggle,IRISS[iris].gdo)
			end
		else
			print("Iris spawner not found!")
			print("Proceeding...")
		end
	end
end

ringspawnercheck()
irisspawnercheck()

print("-------------------------")
print("STARGATE MOD FULLY ACTIVE")
print("version "..VERSION)
print("-------------------------")